<CsoundSynthesizer>
<CsOptions>
</CsOptions>
<CsInstruments>
sr = 44100
ksmps = 32
nchnls = 2
0dbfs = 1

  instr set_transp
 ;receive the live audio input
aLvIn     inch      1
 ;create software busses
          chn_k     "transp1", 3 
          chn_k     "transp2", 3 
          chn_k     "transp3", 3 
          chn_k     "transp4", 3 
 ;set initial values
          chnset    -449, "transp1" 
          chnset    -315, "transp2" 
          chnset    71, "transp3" 
          chnset    688, "transp4" 
 ;receive the values from the software busses
kCent1    chnget    "transp1" 
kCent2    chnget    "transp2" 
kCent3    chnget    "transp3" 
kCent4    chnget    "transp4" 
 ;perform fourier transform
fLvIn     pvsanal   aLvIn, 1024, 256, 1024, 1 
 ;perform four voice transposition
fTp1      pvscale   fLvIn, cent(kCent1) 
fTp2      pvscale   fLvIn, cent(kCent2) 
fTp3      pvscale   fLvIn, cent(kCent3) 
fTp4      pvscale   fLvIn, cent(kCent4) 
 ;resynthesize
aTp1      pvsynth   fTp1 
aTp2      pvsynth   fTp2 
aTp3      pvsynth   fTp3 
aTp4      pvsynth   fTp4 
 ;panning
aL1, aR1  pan2      aTp1, .1 
aL2, aR2  pan2      aTp2, .33 
aL3, aR3  pan2      aTp3, .67 
aL4, aR4  pan2      aTp4, .9 
aL        =         (aL1+aL2+aL3+aL4)/3 
aR        =         (aR1+aR2+aR3+aR4)/3 
 ;add and apply envelope
kHul      linsegr   0, .3, 1, p3-0.3, 1, .5, 0 
aL        =         aL * kHul 
aR        =         aR * kHul 
          outs      aL, aR 
  endin
  
  instr change_transp  
          chnset    -568, "transp1" 
          chnset    -386, "transp2" 
          chnset    428, "transp3" 
          chnset    498, "transp4" 
          turnoff
  endin  

</CsInstruments>
<CsScore>
i "set_transp" 0 100
;i "change_transp" 5 1
</CsScore>
</CsoundSynthesizer>



<bsbPanel>
 <label>Widgets</label>
 <objectName/>
 <x>863</x>
 <y>239</y>
 <width>190</width>
 <height>105</height>
 <visible>true</visible>
 <uuid/>
 <bgcolor mode="nobackground">
  <r>231</r>
  <g>46</g>
  <b>255</b>
 </bgcolor>
 <bsbObject version="2" type="BSBButton">
  <objectName>button1</objectName>
  <x>27</x>
  <y>16</y>
  <width>131</width>
  <height>34</height>
  <uuid>{f9790e01-2c09-4c3f-a202-42e5cae312d2}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <type>event</type>
  <pressedValue>1.00000000</pressedValue>
  <stringvalue/>
  <text>change transp!</text>
  <image>/</image>
  <eventLine>i "change_transp" 0 1</eventLine>
  <latch>false</latch>
  <latched>true</latched>
 </bsbObject>
</bsbPanel>
<bsbPresets>
</bsbPresets>
